import 'dart:async';

import 'package:flutter/services.dart';

import 'src/collector_type.dart';

export 'src/collector_type.dart';

class Aware {
  static const MethodChannel _channel = MethodChannel('aware');

  static Future<String> register({String ctoken}) async {
    return await _channel.invokeMethod('register', ctoken);
  }

  static Future<bool> unregister() async {
    return await _channel.invokeMethod('unregister');
  }

  static Future<bool> isRegistered() async {
    return await _channel.invokeMethod('isRegistered');
  }

  static Future<bool> isServiceEnabled() async {
    return await _channel.invokeMethod('isServiceEnabled');
  }

  static Future<void> setServiceEnabled(bool value) async {
    await _channel.invokeMethod('setServiceEnabled', value);
  }

  static Future<String> getProfile() async {
    return await _channel.invokeMethod('getProfile');
  }

  static Future<String> getClientSecret() async {
    return await _channel.invokeMethod('getClientSecret');
  }

  static Future<void> collect(List<CollectorType> types) async {
    final collectorTypeNames = types.map((type) => convertCollectorTypeToString(type)).toList();
    await _channel.invokeMethod('collect', collectorTypeNames);
  }
}
